#include "io.h"
#include <iostream>

#include <cstdio>

namespace minigrail
{

mGDFA *IO::read_dfa_file(std::string &str){

	mGDFA *mfm = new mGDFA();
	std::ifstream file;
	file.open(str.c_str());
	while(!file.eof()){
		file >> *mfm;
	}
	file.close();
	return mfm;
}

void IO::write_dfa_file(mGDFA fmachine,std::string &str){
	std::ofstream myfile;
	myfile.open (str.c_str());
	myfile << fmachine;
	myfile.close();

}



mGNFA *IO::read_nfa_file(std::string &str){

	mGNFA *mfm = new mGNFA();
	std::ifstream file;
	file.open(str.c_str());
	while(!file.eof()){
		file >> *mfm;
	}
	file.close();
	return mfm;
}

void IO::write_nfa_file(mGNFA fmachine,std::string &str){
	std::ofstream myfile;
	myfile.open (str.c_str());
	myfile << fmachine;
	myfile.close();

}



void IO::print_string(std::string &str){
	std::cout << str;
}

void IO::print_int(int value){
	std::cout << value << std::endl;
}


void IO::print_dfa(mGDFA fmachine){
	std::cout << fmachine << std::endl;

}


void IO::print_nfa(mGNFA fmachine){
	std::cout << fmachine << std::endl;

}
/* NOTE: minigrail does not support regex
void IO::print_regex(re<char> regex){
	std::cout << regex << std::endl;
}

*/

}
