#ifndef LISA_MINIGRAIL_NFA_H
#define LISA_MINIGRAIL_NFA_H

namespace minigrail
{

class NFA {
//Legend :
// " // " = implemented
// " * " =  has been inserted into symbol table
// " + " =  the function has been installed in the compiler

public:
	static int 			size(mGNFA nfa);
	static int  		maxstring(mGNFA nfa);

	static mGNFA 		*reverse(mGNFA nfa);
	static mGNFA 		*unionnfa(mGNFA nfa1,mGNFA nfa2);
	static mGNFA		*plus(mGNFA nfa);
	static mGNFA		*star(mGNFA nfa);
	static mGNFA		*reachable(mGNFA nfa);
	static mGNFA		*reduce(mGNFA nfa);
	static mGNFA		*complete(mGNFA nfa);
	static mGNFA		*cartesian(mGNFA nfa);
	static mGNFA		*cross(mGNFA nfa1, mGNFA nfa2);
	static mGNFA		*shuffle(mGNFA nfa1,mGNFA nfa2);
	static mGNFA		*dfatonfa(mGNFA nfa);
	static mGNFA		*concat(mGNFA nfa1, mGNFA nfa2);

	static bool			isDeterministic(mGNFA nfa);
	static bool			isFinite(mGNFA nfa);
	static bool			isComplete(mGNFA nfa);
	static bool			isUniversal(mGNFA nfa);
};


}

#endif
