/*
    file: mGOStream.cpp
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>





  Ostream.cpp


  Created by Ray Rui Zhou on 11-10-09.

  Modified by Cezar Campeanu <ccampeanu@upei.ca> 2012-07-11


	Modified by Brandon Stewart July 2015
	- Added namespace minigrail
*/

#include <iostream>


namespace minigrail
{


using namespace std;
//out put an array
template<class T>
inline ostream& operator<<(ostream& os, const mGArray<T>& arr)
{
	os << "[";
	for (int a = 0; a < arr.size(); a++)
	{
		os << arr[a];
		os << ",";
	}
	os << "]";
	return os;
}

template<class Key, class T>
inline ostream& operator<<(ostream& os, mGMap<Key, T>& map)
{
	typedef typename mGMap<Key, T>::mGMapItator IT; //TODO ......

	for (IT it = map.begin(); it != map.end(); it++)
	{
		os << "Key[" << (*it).first << "],map to[" << (*it).second << "]"<<std::endl;
	}
	return os;
}
/*
 * I once wrote "mGInt i"
 * here as  the parameter , and of course
 * that will be a bug because
 * the pointer will be double freed,
 * as the value of the the pointer is
 * copied into a new automatic object
 */
inline ostream& operator<<(ostream& os, mGInt& i)
{
	string temp;
	//i.toBinray(temp);
	//os << temp;
	//os<<std::endl;

	//temp.clear();
	i.toBitSet(temp);
	os<<temp;

	return os;
}


inline ostream& operator<<(ostream& os, const mGInt& i)
{
	string temp;

	i.toBitSet(temp);
	os<<temp;

	return os;
}


} //namespace minigrail
