/*
    file: mGDebug.h
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

    Modified by Brandon Stewart July 2015
	  - Added namespace minigrail


 This controls the debug out put of the entire Project,
 any piece of code that needs debug information  output will be issued a
 unique integer, if the integer is inside the debug array, the program will
 output associated debug information
 */

#include <vector>
#include <algorithm>
#include <utility>


namespace minigrail
{

//1. debug array
std::vector<int> DEBUG_TRIGGERS;

//2. debug trigger names
//Brandon Stewart - Note: macros will not end up in the namespace.  It might be
//                        worth while changing them to const int.
#define DEBUG_ALL 0

#define DEBUG_mGNFAtoDFA_Set 1
#define DEBUG_mGArray_getIntersection 2
#define DEBUG_mGArray_member 3
#define DEBUG_mGDFAMinimize_TBF 4
#define DEBUG_mGDFA_getDestination 5
#define DEBUG_mGNFA_attach 6
#define DEBUG_mGDFAMinimize_Moore 7
#define DEBUG_mGDFAMinimize_Hopcroft 8

//enable a triggerd
void DEBUG_TRIGGER(int index)
{
	DEBUG_TRIGGERS.push_back(index);
}
//detect if one debug mode is triggerd
bool DEBUG_TRIGGERED(int index)
{

	return (std::find(DEBUG_TRIGGERS.begin(), DEBUG_TRIGGERS.end(), index)
			!= DEBUG_TRIGGERS.end());

}


}
