/*
    file: mGSymbolTable.h
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

	Modified by Brandon Stewart July 2015
	  - Added namespace minigrail


global objects that are needed
*/


namespace minigrail
{

mGArray<mGInt> mGIntTable;
mGMap<mGInt, string> mGIntStringTable;

void reset()
{
	mGIntTable.clear();
	mGIntStringTable.clear();
}
;

const int getSymbolTableIndex(const string& str)
{
	//return 0;

	mGInt tempInt(str);
	int index = mGIntTable.member(tempInt);

	//cout<<str<<":"<<tempInt<<":"<<index<<endl;

	if (index >= 0)
	{
		return index;
	}
	else
	{
		mGIntTable += tempInt;

		mGIntStringTable[mGInt(tempInt)] = str;

		return (mGIntTable.size() - 1);

	}

}
;

const string& indexToString(int index)
{

	return mGIntStringTable[mGIntTable[index]];

}
;

} //namespace minigrail
