/*
    file: mGTransition.cpp
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

    Modified by Brandon Stewart July 2015
	  - Added namespace minigrail

 Implementation of member methods  in
 mGTransition Class

 */

 namespace minigrail
 {

//constructor with 3 integers
mGTransition::mGTransition(int s, int l, int e)
{
	start.setNumber(s);
	label = l;
	end.setNumber(e);
}

mGTransition::mGTransition(int s, string l, int e)
{
	start.setNumber(s);
	label = getSymbolTableIndex(l);
	end.setNumber(e);
}

//assignment
mGTransition& mGTransition::operator=(const mGTransition& t)
{

	start = t.start; //question:protected?
	label = t.label;
	end = t.end;
	return *this;
}

//less than
bool mGTransition::operator<(const mGTransition& t) const
{
	if (start < t.start)
	{
		return true;
	}
	if (start > t.start)
	{
		return false;

	}

	if (label < t.label)
	{
		return true;
	}
	if (label > t.label)
	{
		return false;
	}

	if (end < t.end)
	{
		return true;
	}
	if (end > t.end)
	{
		return false;
	}

	//equal
	return false;
}

//bigger than
bool mGTransition::operator>(const mGTransition& t) const
{
	if (start < t.start)
	{
		return false;
	}
	if (start > t.start)
	{
		return true;

	}

	if (label < t.label)
	{
		return false;
	}
	if (label > t.label)
	{
		return true;
	}

	if (end < t.end)
	{
		return false;
	}
	if (end > t.end)
	{
		return true;
	}

	//equal
	return false;
}

//equal
bool mGTransition::operator==(const mGTransition& t) const
{

	return (start == t.start) && (label == t.label) && (end == t.end);

}

bool mGTransition::sameStartAndLabel(const mGTransition& t) const
{

	return (start == t.start) && (label == t.label);

}

//set
void mGTransition::setStart(const int i)
{
	mGState s(i);

	start = s;

}

void mGTransition::setEnd(const int i)
{
	mGState s(i);

	end = s;

}

void mGTransition::null()
{
	start.setNumber(NULL_INT);
	label = NULL_INT;
	end.setNumber(NULL_INT);

}

void mGTransition::getReverseCopy(mGTransition& cp)
{
	cp.setEnd(this->getStart());
	cp.setStart(this->getEnd());
	cp.setLabel(this->getLabel());

}

} //namespace minigrail
