/*
*    Language Investigator and Stractural Analyzer (LISA) -
*    A descriptive programming language
*
* FILE:     stack.c
* AUTHOR: 	Brandon Stewart
* CREATED:  2015-07-13
* LICENCE : LGPL
*
* Project Manager:	Dr. Cezar Campeanu (ccampeanu@upei.ca)
*
*
* This stack is used in holding the namespaces used in LISA.  The last "using ..."
* statement in a LISA source file will be at the top of the stack, and take
* priority over other namespaces used.
*
* The data this stack holds are ints.
*
*/

#include "stack.h"

//should have a better way to init a stack
//void StackInitialize(Stack* stack)
//{
//
//}

/*
*
*
*
*
*/
void StackDelete(Stack** stack)
{
    Stack* temp;
    while (!StackIsEmpty(*stack))
    {
        temp = *stack;
        *stack = (*stack)->node;

        //*stack = NULL;
        free(temp);
    }
    *stack = NULL;

}


void StackPush(Stack** stack, int namespace)
{
    if (StackIsEmpty(*stack))
    {
        *stack = malloc(sizeof(Stack));
        (*stack)->data = namespace;
        (*stack)->node = NULL;
    }
    else
    {
        Stack* temp = malloc(sizeof(Stack));
        temp->data = namespace;
        temp->node = *stack;

        (*stack) = temp;



    }
}

int StackPop(Stack** stack)
{

    if (!StackIsEmpty(*stack))
    {
        int temp = (*stack)->data;
        *stack = (*stack)->node;

        return temp;
    }


    return -1; //not in symbol table
}

int StackIsEmpty(Stack* stack)
{

    return !stack;

}
