/*
*    Language Investigator and Stractural Analyzer (LISA) -
*    A descriptive programming language
*
* FILE:     stack.h
* AUTHOR: 	Brandon Stewart
* CREATED:  2015-07-13
* LICENCE : LGPL
*
* Project Manager:	Dr. Cezar Campeanu (ccampeanu@upei.ca)
*
*
* This stack (more like a linked list in its current implementation) is used
* in holding the namespaces used in LISA.  The last "using ..."
* statement in a LISA source file will be at the top of the stack, and take
* priority over other namespaces used.
*
* The only data this stack (linked list) holds are indexes to the symbol table.
*
*/

#ifndef LISA_SRC_STACK_H
#define LISA_SRC_STACK_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*
* A Node is an element in this stack.
* Each one has some data (int), and a pointer to the next node in the stack
*
*
*/
typedef struct Node
{
    int data; //for the namespace name
    struct Node* node; //linked implementation

}Stack;


//NOT IMPLEMENTED
//void StackInitialize(Stack* stack);

void StackDelete(Stack** stack);


void StackPush(Stack** stack, int namespace);

int StackPop(Stack** stack);

int StackIsEmpty(Stack* stack);


#endif
